#include "StdAfx.h"
#include "BackGround.h"
#include "Resource.h"

extern HINSTANCE g_hInstance;

static LPCWSTR m_szImageFileName;  //      
static CImage *m_pImage;  //    
static Gdiplus::Graphics *m_pGraphics;
static Gdiplus::Bitmap *m_pBitmap;
static Gdiplus::ImageAttributes *m_pImageAttr;
static HDC m_hDC;
static HDC m_hMemDC;

//====================================================================================================
// CBackGround::Init() -   
//====================================================================================================
BOOL CBackGround::Init() {
	m_pImage = new CImage;  //    
		
	WCHAR szFileName[_MAX_PATH] = {0};
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	//WCHAR szFname[_MAX_FNAME];
	//WCHAR szExt[_MAX_EXT];
	
	GetModuleFileNameW(g_hInstance, szFileName, _MAX_PATH);
	
	//    dll  
	_wsplitpath_s(szFileName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, NULL, 0, NULL, 0);
		
	//      ".\\Pics\\Main.*"   bmp, jpg, gif, png, tif
	//    ,     IDB_MAINPIC
	
	_wmakepath_s(szFileName, _MAX_PATH, szDrive, szDir, L"Pics\\Main", L"bmp");
	m_szImageFileName = szFileName;  // L".\\Pics\\Main.bmp";  //     
	
	m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);
	
	if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
		_wmakepath_s(szFileName, _MAX_PATH, szDrive, szDir, L"Pics\\Main", L"jpg");
		m_szImageFileName = szFileName;  // L".\\Pics\\Main.jpg";  //     
		m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);  // Gdiplus::Bitmap
	
		if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
			_wmakepath_s(szFileName, _MAX_PATH, szDrive, szDir, L"Pics\\Main", L"gif");
			m_szImageFileName = szFileName;  // L".\\Pics\\Main.gif";  //     
			m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);  // Gdiplus::Bitmap
	
			if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
				_wmakepath_s(szFileName, _MAX_PATH, szDrive, szDir, L"Pics\\Main", L"png");
				m_szImageFileName = szFileName;  // L".\\Pics\\Main.png";  //     
				m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);  // Gdiplus::Bitmap
	
			  if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
					_wmakepath_s(szFileName, _MAX_PATH, szDrive, szDir, L"Pics\\Main", L"tif");
				  m_szImageFileName = szFileName;  // L".\\Pics\\Main.tif";  //     
				  m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);  // Gdiplus::Bitmap
	
				  if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
					  m_szImageFileName = NULL;  //     
	
					  m_pBitmap = Gdiplus::Bitmap::FromResource(g_hInstance, MAKEINTRESOURCE(IDB_MAINPIC));
	
				    if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
					    MessageBox(GetActiveWindow(), L"    IDB_MAINPIC!", L"", MB_OK);
					    //exit(1);
							return FALSE;
	          }  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
	  			}  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
	 			}  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
			}  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
		}  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
	}  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))
	  
	m_pImageAttr = new Gdiplus::ImageAttributes;  // Gdiplus::ImageAttributes
	m_pImageAttr->SetWrapMode(Gdiplus::WrapModeTile);  //  ""
	  
	m_hDC = CreateCompatibleDC(GetDC(NULL));
	
	m_pGraphics = new Gdiplus::Graphics(m_hDC);
	
	//m_pBitmapSize = new CSize(m_pBitmap->GetWidth(), m_pBitmap->GetHeight());  //    
	
	RECT R = {0};
	//GetWindowRect(m_hClientWnd, &R);
	
	//       
	BOOL bResult = SystemParametersInfo(SPI_GETWORKAREA, 0, &R, 0);
	
	//      m_hMemDC   
	HDC hDCNull = GetDC(NULL);
	m_hMemDC = CreateCompatibleDC(hDCNull);		  
	HBITMAP hDCImage = CreateCompatibleBitmap(hDCNull, R.right, R.bottom);
	hDCImage = (HBITMAP) SelectObject(m_hMemDC, hDCImage);		  
	ReleaseDC(NULL, hDCNull);
			  
	//       
	Gdiplus::TextureBrush TBrush(m_pBitmap);
	
	//        
	m_pGraphics = new Gdiplus::Graphics(m_hMemDC);
	
	//     Gdiplus::Rect
	Gdiplus::Rect RClient(0, 0, R.right, R.bottom);
	
	//  ( - WrapModeTile,  )      
	//TBrush.SetWrapMode(WrapModeTile);
	m_pGraphics->FillRectangle(&TBrush, RClient);

	return TRUE;
}  // CBackGround::Init()

//====================================================================================================
// CBackGround::CBackGround() - 
//====================================================================================================
CBackGround::CBackGround() {  //  : m_pBitmapSize(NULL)
	if(!Init()) return;
}  // CBackGround::CBackGround()

//====================================================================================================
// CBackGround::~CBackGround() - 
//====================================================================================================
CBackGround::~CBackGround(void) {
}  // CBackGround::~CBackGround()

//====================================================================================================
// CBackGround::LoadBitmapFromFile()
//====================================================================================================
BOOL CBackGround::LoadBitmapFromFile(LPCTSTR pszFileName) {
	m_szImageFileName = pszFileName;  //     
	m_pBitmap = new Gdiplus::Bitmap(m_szImageFileName);

	if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
		//MessageBox(GetActiveWindow(), m_szImageFileName, L" -   :", MB_OK);
	  return FALSE;
  }  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))

  return TRUE;
}  // CBackGround::LoadBitmapFromFile()

//====================================================================================================
// CBackGround::LoadBitmapFromResource()
//====================================================================================================
BOOL CBackGround::LoadBitmapFromResource(UINT nIdResource) {
	m_szImageFileName = NULL;  //     

	m_pBitmap = Gdiplus::Bitmap::FromResource(g_hInstance, MAKEINTRESOURCE(nIdResource));

	if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
    //MessageBox(GetActiveWindow(), L"   nIdResource!", L"", MB_OK);
    return FALSE;
  }  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))

	return TRUE;
}  // CBackGround::LoadBitmapFromResource()

//====================================================================================================
// CBackGround::LoadBitmap()
//====================================================================================================
BOOL CBackGround::LoadBitmap(LPCWSTR pszFileName) {
	if(pszFileName) {
		if(!LoadBitmapFromFile(pszFileName)) {
			if(!LoadBitmapFromResource()) {
				return FALSE;
			}  // if(!LoadBitmapFromResource())
		}  // if(!LoadBitmapFromFile(pszFileName))
	}  // if(pszFileName)

  if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight())) {
    //MessageBox(GetActiveWindow(), L"m_pBitmap    !", L"", MB_OK);
    return FALSE;
  }  // if(!m_pBitmap || (m_pBitmap && !m_pBitmap->GetHeight()))

  UINT nFrameCount = m_pBitmap->GetFrameCount(&Gdiplus::FrameDimensionTime);

	//     
  //CRect R(0, 0, 0, 0);
  //GetClientRect(m_hClientWnd, &R);

	//      
	RECT R = {0};
  BOOL bResult = SystemParametersInfo(SPI_GETWORKAREA, 0, &R, 0);

	Gdiplus::RectF RectF((float) R.left, (float) R.top, (float) R.right, (float) R.bottom);

	m_pGraphics->DrawImage(m_pBitmap, RectF, 0, 0, RectF.Width, RectF.Height, Gdiplus::UnitPixel, m_pImageAttr);		

	return TRUE;
}  // CBackGround::LoadBitmap()

//====================================================================================================
// CBackGround::OpenImage()
//====================================================================================================
void CBackGround::OpenImage(HWND hClientWnd) {
	WCHAR szPathName[_MAX_PATH] = {0};
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	//WCHAR szFname[_MAX_FNAME];
	//WCHAR szExt[_MAX_EXT];

	GetModuleFileName(g_hInstance, szPathName, _MAX_PATH);
	_wsplitpath_s(szPathName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, NULL, 0, NULL, 0);

	//       ".\\Pics\\"      dll
	_wmakepath_s(szPathName, _MAX_PATH, szDrive, szDir, L"Pics", NULL);

  OPENFILENAME OFN = {0};
  WCHAR szFileName[MAX_PATH] = {0};

  OFN.lStructSize = sizeof(OFN);  // SEE NOTE BELOW
  OFN.hwndOwner = GetParent(hClientWnd);  // g_hMainWnd;
  OFN.hInstance = g_hInstance;
  OFN.lpstrFilter = L"Image Files (*.bmp;*.jpg;*.gif;*.png;*.tif)\0*.bmp;*.jpg;*.gif;*.png;*.tif\0"
		L"Image Files (*.bmp)\0*.bmp\0"
		L"Image Files (*.jpg)\0*.jpg\0"
		L"Image Files (*.gif)\0*.gif\0"
		L"Image Files (*.png)\0*.png\0"
		L"Image Files (*.tif)\0*.tif\0"
		L"All Files (*.*)\0*.*\0\0";
  //   LPWSTR       lpstrCustomFilter;
  //   DWORD        nMaxCustFilter;
  OFN.nFilterIndex = 0;
  OFN.lpstrFile = szFileName;
  OFN.nMaxFile = MAX_PATH;
  //OFN.lpstrFileTitle = NULL;
  //   DWORD        nMaxFileTitle;
  OFN.lpstrInitialDir = szPathName;
  OFN.lpstrTitle = L"   ";
  OFN.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  //   WORD         nFileOffset;
  OFN.lpstrDefExt = L"bmp";
  //   LPCWSTR      lpstrDefExt;
  //   LPARAM       lCustData;
  //   LPOFNHOOKPROC lpfnHook;
  //   LPCWSTR      lpTemplateName;

  if(GetOpenFileName(&OFN)) {
		//MessageBox(hWnd, OFN.lpstrFile, L" ", MB_OK);
		LoadBitmap(OFN.lpstrFile);

		//    (  -   )		
		ShowWindow(hClientWnd, SW_HIDE);
		ShowWindow(hClientWnd, SW_SHOW);
  }  // if(GetOpenFileName(&OFN))
}  // CBackGround::OpenImage()

//====================================================================================================
// CBackGround::DoPaint()
//====================================================================================================
void CBackGround::DoPaint(HWND hClientWnd) {
	//RECT R;
	//GetClientRect(m_hClientWnd, &R);

  PAINTSTRUCT PS = {0};
  HDC hDC = BeginPaint(hClientWnd, &PS);
  RECT R = PS.rcPaint;
  
  BitBlt(
  	hDC,
  	R.left,
  	R.top,
  	R.right - R.left,
  	R.bottom - R.top,
  	m_hMemDC,
  	R.left,
  	R.top,
  	SRCCOPY
  );
  
  EndPaint(hClientWnd, &PS);
}  // CBackGround::DoPaint()

//====================================================================================================
// CBackGround::CloseExtWindow() -   
//====================================================================================================
void CBackGround::CloseExtWindow(HWND hWnd) {
	//    
	HWND hWndParent = GetParent(hWnd);

	ShowWindow(hWnd, SW_HIDE);
	//SetParent(hWnd, NULL);
	CloseWindow(hWnd);

	//   
	SetActiveWindow(hWndParent);
	SetFocus(hWndParent);
}  // CBackGround::CloseExtWindow()

//====================================================================================================
// CBackGround::AboutDll() -   (  MessageBox()) " "
//====================================================================================================
void CBackGround::AboutDll(HWND hWnd) {
	MessageBox(hWnd, 
		L" \
 dll   \n \
177-183     .\n\n \
(c) Emery Emerald\n \
E-Mail: emmerald@rambler.ru \
		",
		L"  LionExt32.dll / LionExt64.dll",
		MB_OK
	);
}  // CBackGround::AboutDll()

//====================================================================================================
//====================================================================================================
