//====================================================================================================
// LionExt.cpp - Defines the entry point for the DLL application
//====================================================================================================

#include "StdAfx.h"
#include "MainWndSubclassing.h"
#include "MDIBackGround.h"
#include "ExtWindow.h"

//====================================================================================================
// Initialized Data to be shared with all instance of the dll
//====================================================================================================
#pragma data_seg("Shared")
	HINSTANCE g_hInstance = NULL;
  HWND g_hMainWnd = NULL;  //  hWnd   "1:"
  HWND g_hMDIClientWnd = NULL;  //  hWnd MDIClient'a "1:"
	HWND g_hExtWnd = NULL;  //  
	CMainWndSubclassing *g_pMainWndSubclassing = NULL;
	CMDIBackGround *g_pMDIBackGround = NULL;
	ULONG_PTR g_pGDIToken = NULL;
  WCHAR szDest[_MAX_LINE] = {0};  // 
#pragma data_seg()

//====================================================================================================
// ReLoadLibrary() -   
//====================================================================================================
void ReLoadLibrary(HMODULE hModule) {
	WCHAR szDllName[_MAX_PATH] = {0};

	//     dll
	GetModuleFileName(hModule, szDllName, _MAX_PATH);

	//    dll
	HMODULE hCurDll = LoadLibrary(szDllName);
		
	if(!hCurDll) {
		MessageBox(NULL, L"   dll  !", L"", MB_OK);
	}  // if(!hCurDll)
}  // ReLoadLibrary()

//====================================================================================================
// DllMain()
//====================================================================================================
BOOL APIENTRY DllMain(HMODULE hModule, DWORD dwReason, LPVOID lpReserved) {
	switch(dwReason) {
		case DLL_PROCESS_ATTACH: {
			g_hInstance = (HINSTANCE) hModule;
			BOOL bShow = FALSE;
			//bShow = TRUE;  //   

			//----------------------------------------------------------------------------------------------------
			//  GDI+
			//----------------------------------------------------------------------------------------------------

			Gdiplus::GdiplusStartupInput gdipStartupInput;
			GdiplusStartup(&g_pGDIToken, &gdipStartupInput, 0);

			//----------------------------------------------------------------------------------------------------
			//   g_hMainWnd   "1:"
			//----------------------------------------------------------------------------------------------------

			g_hMainWnd = GetMainWindow1C(bShow);
		
			if(!g_hMainWnd) return TRUE;

			//----------------------------------------------------------------------------------------------------
			//       
			//----------------------------------------------------------------------------------------------------

			//      
			RECT R = {0};
			BOOL bResult = SystemParametersInfo(SPI_GETWORKAREA, 0, &R, 0);

			//  
			MoveWindow(g_hMainWnd, R.left, R.top, R.right - R.left, R.bottom - R.top, TRUE);

			//----------------------------------------------------------------------------------------------------
			//   CMainWndSubclassing    
			//----------------------------------------------------------------------------------------------------

			g_pMainWndSubclassing = new CMainWndSubclassing(g_hMainWnd);
    
			if(!g_pMainWndSubclassing) return TRUE;

			//   
			g_pMainWndSubclassing->Attach();

			//----------------------------------------------------------------------------------------------------
			//   g_hMDIClientWnd  MDI  "1:" 
			//----------------------------------------------------------------------------------------------------

			g_hMDIClientWnd = GetMDIClient1C(g_hMainWnd, bShow);

			if(g_hMDIClientWnd) {  //       177  182
				//----------------------------------------------------------------------------------------------------
				//      MDI 
				//----------------------------------------------------------------------------------------------------

				g_pMDIBackGround = new CMDIBackGround(g_hMDIClientWnd);
    
				if(!g_pMDIBackGround) {
					MessageBox(NULL, L"g_pMDIBackGround == NULL!", L"Error", MB_OK);
					return TRUE;
				}  // if(!g_pMDIBackGround) 

				//     
				if(g_pMDIBackGround->LoadBitmap()) {
					//   MDI 
					g_pMDIBackGround->Attach();
				}  // if(m_pMDIBackGround->LoadBitmap())

				//----------------------------------------------------------------------------------------------------
				//   hMenu  
				//----------------------------------------------------------------------------------------------------

				HMENU hMenu = GetMenu(g_hMainWnd);

				if(hMenu) {  //  177 hMenu   
					//----------------------------------------------------------------------------------------------------
					//  177   " "   ""
					//----------------------------------------------------------------------------------------------------

					HMENU hFileSubMenu = GetSubMenu(hMenu, 0);

					//  
					InsertMenu(hFileSubMenu, 5, MF_SEPARATOR | MF_BYPOSITION , 0, NULL);
		
					//     , ,       ,  
					//   ,   177   
					InsertMenu(hFileSubMenu, 6, MF_STRING | MF_BYPOSITION | MF_ENABLED, ID_FILE_MRU_FILE9, L" \tAlt+I");

					//----------------------------------------------------------------------------------------------------
					//  177   "  LionExt32.dll"   ""
					//----------------------------------------------------------------------------------------------------

					//     
					int nMenuCount = GetMenuItemCount(hMenu);

					//     ("")
					HMENU hHelpSubMenu = GetSubMenu(hMenu, nMenuCount - 1);

					//     
					AppendMenu(hHelpSubMenu, MF_SEPARATOR, 0, NULL);
		
					//     , ,       ,  
					//   ,   177   
					AppendMenu(hHelpSubMenu, MF_STRING | MF_ENABLED, ID_FILE_MRU_FILE16, L"  LionExt32.dll\tAlt+L");
				} else {  // hMenu == NULL
					//----------------------------------------------------------------------------------------------------
					//  182    . ,     ,      
					// .     .
					//----------------------------------------------------------------------------------------------------

					//----------------------------------------------------------------------------------------------------
					//  182,     dll,     (   DLL_PROCESS_ATTACH
					//   )
					//----------------------------------------------------------------------------------------------------

					//   .       dll  1!
					ReLoadLibrary(hModule);
				}  // if(hMenu)

				//----------------------------------------------------------------------------------------------------
				//     177-182 (  -   )		
				//----------------------------------------------------------------------------------------------------

				ShowWindow(g_hMDIClientWnd, SW_HIDE);
				ShowWindow(g_hMDIClientWnd, SW_SHOW);
			} else {  // g_hMDIClientWnd == NULL
				//----------------------------------------------------------------------------------------------------
				//  183   ,    
				//----------------------------------------------------------------------------------------------------
		
				//   
				CExtWindow ExtWindow;  // (g_hInstance)
		
				//         
				int nWidth = R.right - R.left;
				int nHeight = R.bottom - R.top;
				RECT Rect = {nWidth/16, nHeight/16, 7*nWidth/8, 7*nHeight/8};

				//   
				ExtWindow.CreateEx(g_hMainWnd, L" !", Rect);

				//----------------------------------------------------------------------------------------------------
				//  183,     dll,     (   DLL_PROCESS_ATTACH
				//   )
				//----------------------------------------------------------------------------------------------------

				//   
				ReLoadLibrary(hModule);
			}  // if(g_hMDIClientWnd)

			//MessageBox(NULL, L"DLL_PROCESS_ATTACH", L"Info", MB_OK);
			break;
		}  // case DLL_PROCESS_ATTACH
		case DLL_PROCESS_DETACH: {
			//----------------------------------------------------------------------------------------------------
			// ,         
			//----------------------------------------------------------------------------------------------------

			if(g_pMDIBackGround) g_pMDIBackGround->Detach();  //  MDI 
			if(g_pMainWndSubclassing) g_pMainWndSubclassing->Detach();  //  
	
			//----------------------------------------------------------------------------------------------------
			//  GDI+
			//----------------------------------------------------------------------------------------------------

			Gdiplus::GdiplusShutdown(g_pGDIToken);

			//MessageBox(NULL, L"DLL_PROCESS_DETACH!", L"Info", MB_OK);
			break;
		}  // case DLL_PROCESS_DETACH
		case DLL_THREAD_ATTACH: {
			//MessageBox(NULL, L"DLL_THREAD_ATTACH", L"Info", MB_OK);
			break;
		}  // case DLL_THREAD_ATTACH
		case DLL_THREAD_DETACH: {
			//MessageBox(NULL, L"DLL_THREAD_DETACH", L"Info", MB_OK);
			break;
		}  // case DLL_THREAD_DETACH
	}  // if(dwReason == DLL_PROCESS_ATTACH)

  return TRUE;
}  // DllMain()

//====================================================================================================
//====================================================================================================
