#include "StdAfx.h"
#include "MDIBackGround.h"
#include "Resource.h"

extern HINSTANCE g_hInstance;

static WNDPROC m_OrigWndProc;  //    MDI 

//====================================================================================================
// CMDIBackGround::CMDIBackGround() - 
//====================================================================================================
CMDIBackGround::CMDIBackGround(HWND hMDIClientWnd) : 
		m_hMDIClientWnd(NULL), m_szImageFileName(NULL), m_pImage(NULL), m_pGraphics(NULL), m_pBitmap(NULL),
		m_pImageAttr(NULL), m_hDC(NULL), m_hMemDC(NULL), m_pBitmapSize(NULL), m_bIsAttach(FALSE) {

	m_hMDIClientWnd = hMDIClientWnd;  //  MDI 

	if(!Init()) return;
}  // CMDIBackGround::CMDIBackGround()

//====================================================================================================
// CMDIBackGround::~CMDIBackGround() - 
//====================================================================================================
CMDIBackGround::~CMDIBackGround(void) {
}  // CMDIBackGround::~CMDIBackGround()

//====================================================================================================
// CMDIBackGround::Attach()
//====================================================================================================
BOOL CMDIBackGround::Attach() {
	if(!m_hMDIClientWnd) return FALSE;

	m_OrigWndProc = (WNDPROC) ::GetWindowLongPtr(m_hMDIClientWnd, GWLP_WNDPROC);
	
  ::SetWindowLongPtr(m_hMDIClientWnd, GWLP_WNDPROC, (INT_PTR) CMDIBackGround::WindowProc);

	SetWindowPos(m_hMDIClientWnd, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	m_bIsAttach = TRUE;

	return TRUE;
}  // CMDIBackGround::Attach()

//====================================================================================================
// CMDIBackGround::Detach()
//====================================================================================================
void CMDIBackGround::Detach() {
	if(!m_bIsAttach || !m_hMDIClientWnd || !m_OrigWndProc) return;

	// Remove the subclass procedure
	SetWindowLong(m_hMDIClientWnd, GWLP_WNDPROC, (LONG) (LONG_PTR) m_OrigWndProc);

	m_bIsAttach = FALSE;
}  // CMDIBackGround::Detach()

//====================================================================================================
// CMDIBackGround::WindowProc()
//====================================================================================================
LRESULT CMDIBackGround::WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch(uMsg) {
		case WM_ERASEBKGND:
			//        
      return 0;
    case WM_PAINT:
			DoPaint(hWnd);
		  return 0;
		default:
			break;
	}  // switch(uMsg)

	return CallWindowProc(m_OrigWndProc, hWnd, uMsg, wParam, lParam);
}  // CMDIBackGround::WindowProc()

//====================================================================================================
//====================================================================================================
