#include "StdAfx.h"
#include "MainWndSubclassing.h"
#include "BackGround.h"
#include "MDIBackGround.h"

extern HINSTANCE g_hInstance;
extern HWND g_hExtWnd;  //  

extern CMainWndSubclassing *g_pMainWndSubclassing;
extern CMDIBackGround *g_pMDIBackGround;
extern ULONG_PTR g_pGDIToken;

static WNDPROC m_OrigWndProc;  //    MDI 

//====================================================================================================
// CMainWndSubclassing::CMainWndSubclassing() - 
//====================================================================================================
CMainWndSubclassing::CMainWndSubclassing(HWND hMainWnd) : m_bIsAttach(FALSE) {  // m_OrigWndProc(NULL), 
	m_hMainWnd = hMainWnd;  //   
}  // CMainWndSubclassing::CMainWndSubclassing()

//====================================================================================================
// CMainWndSubclassing::~CMainWndSubclassing() - 
//====================================================================================================
CMainWndSubclassing::~CMainWndSubclassing(void) {
}  // CMainWndSubclassing::~CMainWndSubclassing()

//====================================================================================================
// CMainWndSubclassing::Attach()
//====================================================================================================
BOOL CMainWndSubclassing::Attach() {
	if(!m_hMainWnd) return FALSE;

	m_OrigWndProc = (WNDPROC) ::GetWindowLongPtr(m_hMainWnd, GWLP_WNDPROC);
	
  ::SetWindowLongPtr(m_hMainWnd, GWLP_WNDPROC, (INT_PTR) CMainWndSubclassing::WindowProc);
	
  SetWindowPos(m_hMainWnd, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	m_bIsAttach = TRUE;

	return TRUE;
}  // CMainWndSubclassing::Attach()

//====================================================================================================
// CMainWndSubclassing::Detach()
//====================================================================================================
void CMainWndSubclassing::Detach() {
	if(!m_bIsAttach || !m_hMainWnd || !m_OrigWndProc) return;

	// 
	SetWindowLong(m_hMainWnd, GWLP_WNDPROC, (LONG) (LONG_PTR) m_OrigWndProc);

	m_bIsAttach = FALSE;
}  // CMainWndSubclassing::Detach()
//====================================================================================================
// CMainWndSubclassing::WindowProc()
//====================================================================================================
LRESULT CMainWndSubclassing::WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch(uMsg) {
		case WM_ERASEBKGND:
			//        
      return 0;
    case WM_SYSCHAR:  //         Alt + Char
    case WM_MENUCHAR: {  //         Alt + Char
      if(wParam == 'i' || wParam == 'I' || wParam == 0x448 || wParam == 0x428) {  // 0x448 = ''; 0x428 = ''
				OpenImage(hWnd);  //     
				return 0;
      }  // if(wParam == 'i' || wParam == 'I' || wParam == 0x448 || wParam == 0x428)

			else if(wParam == 'l' || wParam == 'L' || wParam == 0x434 || wParam == 0x414) {  // 0x434 = ''; 0x414 = ''
				AboutDll(hWnd);
				return 0;
      }  // else if(wParam == 'l' || wParam == 'L' || wParam == 0x434 || wParam == 0x414)

			break;
    }  // case WM_MENUCHAR:
		case WM_COMMAND: {
      switch(wParam) {
				//     , ,       ,  
				//   ,   1   
				case ID_FILE_MRU_FILE9: {
					OpenImage(hWnd);  //     
					return 0;
        }  // case ID_FILE_MRU_FILE9:
				case ID_FILE_MRU_FILE16: {
					AboutDll(hWnd);
					return 0;
        }  // case ID_FILE_MRU_FILE16:
        default: {
  			  break;
        }  // default:
      }  // switch(wParam)

			break;
		}  // case WM_COMMAND:
		case WM_CLOSE:
		  if(g_pMDIBackGround) g_pMDIBackGround->Detach();  // 
		  if(g_pMainWndSubclassing) g_pMainWndSubclassing->Detach();  // 
	
			//----------------------------------------------------------------------------------------------------
			//  GDI+
			//----------------------------------------------------------------------------------------------------
		  if(g_pGDIToken) Gdiplus::GdiplusShutdown(g_pGDIToken);

			//  
			if(g_hExtWnd) DestroyWindow(g_hExtWnd);			
			if(hWnd) DestroyWindow(hWnd);

			return 0;
		default:
			break;
	}  // switch(uMsg)

	return CallWindowProc(m_OrigWndProc, hWnd, uMsg, wParam, lParam);  // pThis->
}  // CMainWndSubclassing::WindowProc()

//====================================================================================================
//====================================================================================================
